/[MITgcm]/MITgcm/tools/genmake2
ViewVC logotype

Diff of /MITgcm/tools/genmake2

Parent Directory Parent Directory | Revision Log Revision Log | View Revision Graph Revision Graph | View Patch Patch

revision 1.49 by edhill, Tue Nov 25 17:22:47 2003 UTC revision 1.64 by edhill, Sun Jan 25 00:22:57 2004 UTC
# Line 13  Line 13 
13  test_for_package_in_cpp_options() {  test_for_package_in_cpp_options() {
14      cpp_options=$1      cpp_options=$1
15      pkg=$2      pkg=$2
16      grep -i "#define.*ALLOW_$pkg" $cpp_options > /dev/null 2>&1      test_for_string_in_file $cpp_options "^[ ]*#define.*ALLOW_$pkg" || exit 99
17      RETVAL=$?      test_for_string_in_file $cpp_options "^[ ]*#undef.*ALLOW_$pkg" || exit 99
18      if test "x${RETVAL}" = x0 ; then      test_for_string_in_file $cpp_options "^[ ]*#define.*DISABLE_$pkg" || exit 99
19          echo "Error: In $cpp_options there is an illegal line: #define ALLOW_$pkg"      test_for_string_in_file $cpp_options "^[ ]*#undef.*DISABLE_$pkg" || exit 99
20          exit 99  }
21      fi  
22      grep -i "#undef.*ALLOW_$pkg" $cpp_options > /dev/null 2>&1  # Search for particular CPP #cmds associated with MPI
23      RETVAL=$?  # usage: test_for_mpi_in_cpp_eeoptions CPP_file
24      if test "x${RETVAL}" = x0 ; then  test_for_mpi_in_cpp_eeoptions() {
25          echo "Error: In $cpp_options there is an illegal line: #undef ALLOW_$pkg"      cpp_options=$1
26          exit 99      test_for_string_in_file $cpp_options "^[ ]*#define.*ALLOW_USE_MPI" || exit 99
27      fi      test_for_string_in_file $cpp_options "^[ ]*#undef.*ALLOW_USE_MPI" || exit 99
28      grep -i "#define.*DISABLE_$pkg" $cpp_options > /dev/null 2>&1      test_for_string_in_file $cpp_options "^[ ]*#define.*ALWAYS_USE_MPI" || exit 99
29        test_for_string_in_file $cpp_options "^[ ]*#undef.*ALWAYS_USE_MPI" || exit 99
30    }
31    
32    # Search for particular string in a file. Return 1 if detected, 0 if not
33    # usage: test_for_string_in_file file string
34    test_for_string_in_file() {
35        file=$1
36        strng=$2
37        grep -i "$strng" $file > /dev/null 2>&1
38      RETVAL=$?      RETVAL=$?
39      if test "x${RETVAL}" = x0 ; then      if test "x${RETVAL}" = x0 ; then
40          echo "Error: In $cpp_options there is an illegal line: #define DISABLE_$pkg"          echo -n "Error: In $file there is an illegal line: "
41          exit 99          grep -i "$strng" $file
42            return 1
43      fi      fi
44      grep -i "#undef.*DISABLE_$pkg" $cpp_options > /dev/null 2>&1      return 0
     RETVAL=$?  
     if test "x${RETVAL}" = x0 ; then  
         echo "Error: In $cpp_options there is an illegal line: #undef DISABLE_$pkg"  
         exit 99  
    fi  
45  }  }
46    
47  # Read the $ROOTDIR/pkg/pkg_groups file and expand any references to  # Read the $ROOTDIR/pkg/pkg_groups file and expand any references to
# Line 73  find_possible_configs()  { Line 78  find_possible_configs()  {
78      tmp1=`uname`"_"`uname -m`      tmp1=`uname`"_"`uname -m`
79      tmp2=`echo $tmp1 | sed -e 'y/ABCDEFGHIJKLMNOPQRSTUVWXYZ/abcdefghijklmnopqrstuvwxyz/'`      tmp2=`echo $tmp1 | sed -e 'y/ABCDEFGHIJKLMNOPQRSTUVWXYZ/abcdefghijklmnopqrstuvwxyz/'`
80      tmp3=`echo $tmp2 | sed -e 's/power macintosh/ppc/'`      tmp3=`echo $tmp2 | sed -e 's/power macintosh/ppc/'`
81      PLATFORM=`echo $tmp3 | sed -e 's/i[3-6]86/ia32/' | sed -e 's/athlon/ia32/'`      tmp1=`echo $tmp3 | sed -e 's|x86_64|amd64|'`
82        tmp2=`echo $tmp1 | sed -e 's/i[3-6]86/ia32/' | sed -e 's/athlon/ia32/'`
83        PLATFORM=$tmp2
84      OFLIST=`(cd $ROOTDIR/tools/build_options; ls | grep "^$PLATFORM")`      OFLIST=`(cd $ROOTDIR/tools/build_options; ls | grep "^$PLATFORM")`
85      echo "  The platform appears to be:  $PLATFORM"      echo "  The platform appears to be:  $PLATFORM"
86            
# Line 430  EOF Line 437  EOF
437  }  }
438    
439    
440    check_netcdf_libs()  {
441        cat <<EOF > genmake_tnc.F
442          program fgennc
443    #include "netcdf.inc"
444          integer iret, ncid, xid
445          iret = nf_create('genmake_tnc.nc', NF_CLOBBER, ncid)
446          IF (iret .NE. NF_NOERR) write(*,*) NF_STRERROR(iret)
447          iret = nf_def_dim(ncid, 'X', 11, xid)
448          IF (iret .NE. NF_NOERR) write(*,*) NF_STRERROR(iret)
449          iret = nf_close(ncid)
450          IF (iret .NE. NF_NOERR) write(*,*) NF_STRERROR(iret)
451          end
452    EOF
453        $CPP genmake_tnc.F > genmake_tnc.f  \
454            &&  $FC $FFLAGS $FOPTIM -o genmake_tnc genmake_tnc.f $LIBS >> genmake_tnc.log 2>&1
455        RET_COMPILE=$?
456        test -x ./genmake_tnc  &&  ./genmake_tnc >> genmake_tnc.log 2>&1
457        RETVAL=$?
458        if test "x$RET_COMPILE" = x0 -a "x$RETVAL" = x0 ; then
459            HAVE_NETCDF=t
460        else
461            cat genmake_tnc.log >> genmake_warnings
462        fi
463        rm -f genmake_tnc*
464    }
465    
466    
467  #  Set defaults here  #  Set defaults here
468  COMMANDL="$0 $@"  COMMANDL="$0 $@"
469    
# Line 438  LN= Line 472  LN=
472  S64=  S64=
473  KPP=  KPP=
474  FC=  FC=
475    CPP=
476  LINK=  LINK=
477  # DEFINES="-DWORDLENGTH=4"  # DEFINES="-DWORDLENGTH=4"
478  DEFINES=  DEFINES=
# Line 466  HAVE_SYSTEM= Line 501  HAVE_SYSTEM=
501  HAVE_FDATE=  HAVE_FDATE=
502  FC_NAMEMANGLE=  FC_NAMEMANGLE=
503  HAVE_CLOC=  HAVE_CLOC=
504    HAVE_NETCDF=
505    
506  MODS=  MODS=
507  TOOLSDIR=  TOOLSDIR=
508  SOURCEDIRS=  SOURCEDIRS=
509  INCLUDEDIRS=  INCLUDEDIRS=
510  STANDARDDIRS=  STANDARDDIRS="USE_THE_DEFAULT"
511    
512  PWD=`pwd`  PWD=`pwd`
513  MAKE=make  MAKE=make
# Line 505  TAMC_EXTRA= Line 541  TAMC_EXTRA=
541    
542  #  The following state can be set directly by command-line switches  #  The following state can be set directly by command-line switches
543  gm_s1="OPTFILE PDEPEND PDEFAULT MAKEFILE PLATFORM ROOTDIR MODS DISABLE ENABLE"  gm_s1="OPTFILE PDEPEND PDEFAULT MAKEFILE PLATFORM ROOTDIR MODS DISABLE ENABLE"
544  gm_s2="FC IEEE MPI JAM DUMPSTATE STANDARDDIRS"  gm_s2="FC CPP IEEE MPI JAM DUMPSTATE STANDARDDIRS"
545    
546  #  The following state is not directly set by command-line switches  #  The following state is not directly set by command-line switches
547  gm_s3="LN S64 KPP LINK PACKAGES MAKEDEPEND PDEPEND PDEFAULT INCLUDES FFLAGS FOPTIM "  gm_s3="LN S64 KPP LINK PACKAGES MAKEDEPEND PDEPEND PDEFAULT INCLUDES FFLAGS FOPTIM "
# Line 586  for ac_option ; do Line 622  for ac_option ; do
622          -optfile=* | --optfile=* | -of=* | --of=*)          -optfile=* | --optfile=* | -of=* | --of=*)
623              OPTFILE=$ac_optarg ;;              OPTFILE=$ac_optarg ;;
624                    
625          -adoptfile | --adoptfile | -ad | --ad)          -adoptfile | --adoptfile | -adof | --adof)
626              ac_prev=AD_OPTFILE ;;              ac_prev=AD_OPTFILE ;;
627          -adoptfile=* | --adoptfile=* | -adof=* | --adof=*)          -adoptfile=* | --adoptfile=* | -adof=* | --adof=*)
628              AD_OPTFILE=$ac_optarg ;;              AD_OPTFILE=$ac_optarg ;;
# Line 798  fi Line 834  fi
834  if test "x$LINK" = x ; then  if test "x$LINK" = x ; then
835      LINK=$FC      LINK=$FC
836  fi  fi
 if test "x$CPP" = x ; then  
     CPP="cpp"  
 fi  
837  if test "x$MAKE" = x ; then  if test "x$MAKE" = x ; then
838      MAKE="make"      MAKE="make"
839  fi  fi
840    if test "x$CPP" = x ; then
841        CPP=cpp
842    fi
843    #EH3 === UGLY ===
844    #  The following an ugly little hack to check for $CPP in /lib/ and it
845    #  should eventually be replaced with a more general function that
846    #  searches a combo of the user's path and a list of "usual suspects"
847    #  to find the correct location for binaries such as $CPP.
848    for i in " " "/lib/" ; do
849        echo "#define A a" | $i$CPP > test_cpp 2>&1 && CPP=$i$CPP
850    done
851    #EH3 === UGLY ===
852  echo "#define A a" | $CPP > test_cpp 2>&1  echo "#define A a" | $CPP > test_cpp 2>&1
853  RETVAL=$?  RETVAL=$?
854  if test "x$RETVAL" != x0 ; then  if test "x$RETVAL" != x0 ; then
# Line 888  if test "x$HAVE_CLOC" != x ; then Line 933  if test "x$HAVE_CLOC" != x ; then
933  else  else
934      echo "no"      echo "no"
935  fi  fi
 echo "$FC_NAMEMANGLE" > FC_NAMEMANGLE.h.template  
 cmp FC_NAMEMANGLE.h FC_NAMEMANGLE.h.template > /dev/null 2>&1  
 RETVAL=$?  
 if test "x$RETVAL" != x0 ; then  
     mv -f FC_NAMEMANGLE.h.template FC_NAMEMANGLE.h  
 fi  
936  rm -f genmake_t*  rm -f genmake_t*
937    
938    echo -n "  Can we create NetCDF-enabled binaries...  "
939    check_netcdf_libs
940    if test "x$HAVE_NETCDF" != x ; then
941        echo "yes"
942    else
943        echo "no"
944    fi
945    
946    
947  printf "\n===  Setting defaults  ===\n"  printf "\n===  Setting defaults  ===\n"
948  echo -n "  Adding MODS directories:  "  echo -n "  Adding MODS directories:  "
# Line 956  if test -r $ROOTDIR"/eesupp/src/Makefile Line 1003  if test -r $ROOTDIR"/eesupp/src/Makefile
1003          rm -f make_eesupp.errors          rm -f make_eesupp.errors
1004      else      else
1005          echo "Error: problem encountered while building source files in eesupp:"          echo "Error: problem encountered while building source files in eesupp:"
1006          cat make_eesupp.errors          cat make_eesupp.errors 1>&2
1007          exit 1          exit 1
1008      fi      fi
1009  fi  fi
1010    
1011    #same for exch2
1012    if test -r $ROOTDIR"/pkg/exch2/Makefile" ; then
1013        echo "  Making source files in exch2 from  templates"
1014        ( cd $ROOTDIR"/pkg/exch2/" && $MAKE ) > make_exch2.errors 2>&1
1015        RETVAL=$?
1016        if test "x${RETVAL}" = x0 ; then
1017            rm -f make_exch2.errors
1018        else
1019            echo "Error: problem encountered while building source files in exch2:"
1020            cat make_exch2.errors 1>&2
1021            exit 1
1022        fi
1023    fi
1024    
1025  printf "\n===  Determining package settings  ===\n"  printf "\n===  Determining package settings  ===\n"
1026  if  test "x${PDEPEND}" = x ; then  if  test "x${PDEPEND}" = x ; then
1027      tmp=$ROOTDIR"/pkg/pkg_depend"      tmp=$ROOTDIR"/pkg/pkg_depend"
# Line 1144  for i in $PACKAGES ; do Line 1205  for i in $PACKAGES ; do
1205      fi      fi
1206  done  done
1207    
1208    #  Build MNC templates and check for ability to build and use NetCDF
1209    echo $PACKAGES | grep ' mnc ' > /dev/null 2>&1
1210    RETVAL=$?
1211    if test "x$RETVAL" = x0 ; then
1212        ( cd $ROOTDIR"/pkg/mnc" && $MAKE templates ) > make_mnc.errors 2>&1
1213        RETVAL=$?
1214        if test "x${RETVAL}" = x0 ; then
1215            rm -f make_mnc.errors
1216        else
1217            echo "Error: problem encountered while building source files in pkg/mnc:"
1218            cat make_mnc.errors 1>&2
1219            exit 1
1220        fi
1221        if test "x$HAVE_NETCDF" != xt ; then
1222            cat <<EOF
1223    
1224    WARNING: the "mnc" package has been enabled but tests failed to
1225      compile and/or execute NetCDF applications.  Please check that:
1226    
1227      1) NetCDF is installed for your compiler and
1228      2) the LIBS variable (within the 'optfile") specifies the correct
1229           NetCDF library to link against.
1230      
1231    EOF
1232        fi
1233    fi
1234    
1235  # Create a list of #define and #undef to enable/disable packages  # Create a list of #define and #undef to enable/disable packages
1236  PACKAGES_DOT_H=PACKAGES_CONFIG.h  PACKAGES_DOT_H=PACKAGES_CONFIG.h
# Line 1178  for i in $PACKAGES ; do Line 1265  for i in $PACKAGES ; do
1265  #EH3  WARNING :  This is an UGLY HACK that needs to be removed!!!  #EH3  WARNING :  This is an UGLY HACK that needs to be removed!!!
1266      case $i in      case $i in
1267          aim_v23)          aim_v23)
             DEFINES="$DEFINES -DALLOW_AIM"  
1268              ENABLED_PACKAGES="$ENABLED_PACKAGES -DALLOW_AIM"              ENABLED_PACKAGES="$ENABLED_PACKAGES -DALLOW_AIM"
1269              echo "Warning: ALLOW_AIM is set to enable aim_v23. This is REALLY ugly Jean-Michel :-)"              echo "Warning: ALLOW_AIM is set to enable aim_v23."
1270              ;;              ;;
1271      esac      esac
1272  #EH3  WARNING :  This is an UGLY HACK that needs to be removed!!!  #EH3  WARNING :  This is an UGLY HACK that needs to be removed!!!
# Line 1189  done Line 1275  done
1275    
1276  echo "  Adding STANDARDDIRS"  echo "  Adding STANDARDDIRS"
1277  BUILDDIR=${BUILDDIR:-.}  BUILDDIR=${BUILDDIR:-.}
1278  if test "x$STANDARDDIRS" = x ; then  if test "x$STANDARDDIRS" = xUSE_THE_DEFAULT ; then
1279      STANDARDDIRS="eesupp model"      STANDARDDIRS="eesupp model"
1280  fi  fi
1281  for d in $STANDARDDIRS ; do  if test "x$STANDARDDIRS" != x ; then
1282      adr="$ROOTDIR/$d/src"      for d in $STANDARDDIRS ; do
1283      if test ! -d $adr ; then          adr="$ROOTDIR/$d/src"
1284          echo "Error:  directory $adr not found -- please check that ROOTDIR=\"$ROOTDIR\""          if test ! -d $adr ; then
1285          echo "  is correct and that you correctly specified the STANDARDDIRS option"              echo "Error:  directory $adr not found -- please check that ROOTDIR=\"$ROOTDIR\""
1286          exit 1              echo "  is correct and that you correctly specified the STANDARDDIRS option"
1287      else              exit 1
1288          SOURCEDIRS="$SOURCEDIRS $adr"          else
1289      fi              SOURCEDIRS="$SOURCEDIRS $adr"
1290      adr="$ROOTDIR/$d/inc"          fi
1291      if test ! -d $adr ; then          adr="$ROOTDIR/$d/inc"
1292          echo "Error:  directory $adr not found -- please check that ROOTDIR=\"$ROOTDIR\""          if test ! -d $adr ; then
1293          echo "  is correct and that you correctly specified the STANDARDDIRS option"              echo "Error:  directory $adr not found -- please check that ROOTDIR=\"$ROOTDIR\""
1294          exit 1              echo "  is correct and that you correctly specified the STANDARDDIRS option"
1295      else              exit 1
1296          INCLUDEDIRS="$INCLUDEDIRS $adr"          else
1297      fi              INCLUDEDIRS="$INCLUDEDIRS $adr"
1298  done          fi
1299        done
1300    fi
1301    
1302  echo "  Searching for CPP_OPTIONS.h in order to warn about the presence"  echo "  Searching for *OPTIONS.h files in order to warn about the presence"
1303  echo "    of \"#define ALLOW_PKGNAME\"-type statements:"  echo "    of \"#define \"-type statements that are no longer allowed:"
1304  CPP_OPTIONS=  CPP_OPTIONS=
1305    CPP_EEOPTIONS=
1306  spaths=". $INCLUDEDIRS"  spaths=". $INCLUDEDIRS"
1307    names=`ls -1 "$ROOTDIR/pkg"`
1308  for i in $spaths ; do  for i in $spaths ; do
1309      try="$i/CPP_OPTIONS.h"      try="$i/CPP_OPTIONS.h"
1310      #  echo -n "    trying $try : "      if test -f $try -a -r $try -a "x$CPP_OPTIONS" = x ; then
     if test -f $try -a -r $try ; then  
1311          echo "    found CPP_OPTIONS=\"$try\""          echo "    found CPP_OPTIONS=\"$try\""
1312          CPP_OPTIONS="$try"          CPP_OPTIONS="$try"
1313          break          # New safety test: make sure packages are not mentioned in CPP_OPTIONS.h
1314            for n in $names ; do
1315                test_for_package_in_cpp_options $CPP_OPTIONS $n
1316            done
1317        fi
1318        try="$i/CPP_EEOPTIONS.h"
1319        if test -f $try -a -r $try -a "x$CPP_EEOPTIONS" = x ; then
1320            echo "    found CPP_EEOPTIONS=\"$try\""
1321            # New safety test: make sure MPI is not determined by CPP_EEOPTIONS.h
1322    #**** not yet enabled ****
1323    #        test_for_mpi_in_cpp_eeoptions $try
1324    #**** not yet enabled ****
1325            CPP_EEOPTIONS="$try"
1326      fi      fi
1327  done  done
1328  if test "x$CPP_OPTIONS" = x ; then  if test "x$CPP_OPTIONS" = x ; then
1329      echo "Error: can't find \"CPP_OPTIONS.h\" in the path list: $spaths"      echo "Error: can't find \"CPP_OPTIONS.h\" in the path list: $spaths"
1330      exit 1      exit 1
1331  fi  fi
 # New safety test: make sure packages are not mentioned in CPP_OPTIONS.h  
 names=`ls -1 "$ROOTDIR/pkg"`  
 for n in $names ; do  
     test_for_package_in_cpp_options $CPP_OPTIONS $n  
 done  
   
1332    
1333  #  Here, we build the list of files to be "run through" the adjoint  #  Here, we build the list of files to be "run through" the adjoint
1334  #  compiler.  #  compiler.
# Line 1248  for i in $SOURCEDIRS ; do Line 1343  for i in $SOURCEDIRS ; do
1343      done      done
1344  done  done
1345    
1346    
1347  echo  echo
1348  echo "===  Creating the Makefile  ==="  echo "===  Creating the Makefile  ==="
1349  echo "  setting INCLUDES"  echo "  setting INCLUDES"
# Line 1347  EXE_FTL=$EXECUTABLE"_ftl" Line 1443  EXE_FTL=$EXECUTABLE"_ftl"
1443  EXE_SVD=$EXECUTABLE"_svd"  EXE_SVD=$EXECUTABLE"_svd"
1444    
1445  cat >>$MAKEFILE <<EOF  cat >>$MAKEFILE <<EOF
1446    #
1447    # OPTFILE="$OPTFILE"
1448  #  #
1449  # BUILDDIR     : Directory where object files are written  # BUILDDIR     : Directory where object files are written
1450  # SOURCEDIRS   : Directories containing the source (.F) files  # SOURCEDIRS   : Directories containing the source (.F) files
# Line 1383  EXE_SVD     = ${EXE_SVD} Line 1481  EXE_SVD     = ${EXE_SVD}
1481  ENABLED_PACKAGES = ${ENABLED_PACKAGES}  ENABLED_PACKAGES = ${ENABLED_PACKAGES}
1482  DISABLED_PACKAGES = ${DISABLED_PACKAGES}  DISABLED_PACKAGES = ${DISABLED_PACKAGES}
1483    
1484    # These files are created by Makefile
1485    SPECIAL_FILES = ${PACKAGES_DOT_H} AD_CONFIG.h FC_NAMEMANGLE.h
1486    
1487  EOF  EOF
1488    
1489  #  Note: figure out some way to add Hyades JAM libraries here  #  Note: figure out some way to add Hyades JAM libraries here
# Line 1447  cat >>$MAKEFILE <<EOF Line 1548  cat >>$MAKEFILE <<EOF
1548  .SUFFIXES: .o .f .p .F .c .F90 .f90  .SUFFIXES: .o .f .p .F .c .F90 .f90
1549    
1550  all: \$(EXECUTABLE)  all: \$(EXECUTABLE)
1551  \$(EXECUTABLE): links \$(OBJFILES)  \$(EXECUTABLE): \$(SPECIAL_FILES) \$(SRCFILES) \$(CSRCFILES) \$(HEADERFILES) \$(F90SRCFILES) \$(OBJFILES)
1552          @echo Creating \$@ ...          @echo Creating \$@ ...
1553          \$(LINK) -o \$@ \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) \$(LIBS)          \$(LINK) -o \$@ \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) \$(LIBS)
1554  depend:  depend:
# Line 1455  depend: Line 1556  depend:
1556          \$(MAKEDEPEND) -o .f \$(DEFINES) \$(INCLUDES) \$(SRCFILES)          \$(MAKEDEPEND) -o .f \$(DEFINES) \$(INCLUDES) \$(SRCFILES)
1557          \$(TOOLSDIR)/f90mkdepend >> \$(MAKEFILE)          \$(TOOLSDIR)/f90mkdepend >> \$(MAKEFILE)
1558    
1559  links: \$(SRCFILES) \$(CSRCFILES) \$(HEADERFILES) \$(F90SRCFILES) ${PACKAGES_DOT_H} AD_CONFIG.h  links: \$(SRCFILES) \$(CSRCFILES) \$(HEADERFILES) \$(F90SRCFILES) \$(SPECIAL_FILES)
1560    
1561  small_f: \$(F77FILES) \$(F90FILES)  small_f: \$(F77FILES) \$(F90FILES)
1562    
# Line 1468  clean: Line 1569  clean:
1569  Clean:  Clean:
1570          @make clean          @make clean
1571          @make cleanlinks          @make cleanlinks
1572          -rm -f ${PACKAGES_DOT_H} AD_CONFIG.h          -rm -f \$(SPECIAL_FILES)
1573          -rm -f Makefile.bak genmake_state genmake_*optfile genmake_warnings make.log          -rm -f genmake_state genmake_*optfile genmake_warnings make.log run.log *.bak
1574  CLEAN:  CLEAN:
1575          @make Clean          @make Clean
1576          -find \$(EXEDIR) -name "*.meta" -exec rm {} \;          -find \$(EXEDIR) -name "*.meta" -exec rm {} \;
# Line 1483  makefile: Line 1584  makefile:
1584  cleanlinks:  cleanlinks:
1585          -find . -type l -exec rm {} \;          -find . -type l -exec rm {} \;
1586    
1587  # Special targets  # Special targets ($SPECIAL_FILES) which are create by make
1588  ${PACKAGES_DOT_H}:  ${PACKAGES_DOT_H}:
1589          @echo Creating \$@ ...          @echo Creating \$@ ...
1590          @\$(TOOLSDIR)/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -bPACKAGES_CONFIG_H "Disabled packages:" \$(DISABLED_PACKAGES) " " "Enabled packages:" \$(ENABLED_PACKAGES) > \$@          @\$(TOOLSDIR)/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -bPACKAGES_CONFIG_H "Disabled packages:" \$(DISABLED_PACKAGES) " " "Enabled packages:" \$(ENABLED_PACKAGES) > \$@
1591  AD_CONFIG.h:  AD_CONFIG.h:
1592          @echo Creating \$@ ...          @echo Creating \$@ ...
1593          @\$(TOOLSDIR)/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -bAD_CONFIG_H -UALLOW_ADJOINT_RUN -UALLOW_TANGENTLINEAR_RUN -UALLOW_ECCO_OPTIMIZATION > \$@          @\$(TOOLSDIR)/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -bAD_CONFIG_H -UALLOW_ADJOINT_RUN -UALLOW_TANGENTLINEAR_RUN -UALLOW_ECCO_OPTIMIZATION > \$@
1594    FC_NAMEMANGLE.h:
1595            @echo Creating \$@ ...
1596            echo "$FC_NAMEMANGLE" > \$@
1597    
1598  # The normal chain of rules is (  .F - .f - .o  )  # The normal chain of rules is (  .F - .f - .o  )
1599  .F.f:  .F.f:
# Line 1659  $TOOLSDIR/convert_cpp_cmd2defines "Warni Line 1763  $TOOLSDIR/convert_cpp_cmd2defines "Warni
1763  if test ! -f $PACKAGES_DOT_H ; then  if test ! -f $PACKAGES_DOT_H ; then
1764      mv -f $PACKAGES_DOT_H".tmp" $PACKAGES_DOT_H      mv -f $PACKAGES_DOT_H".tmp" $PACKAGES_DOT_H
1765  else  else
1766      cmp $PACKAGES_DOT_H".tmp" $PACKAGES_DOT_H      cmp $PACKAGES_DOT_H".tmp" $PACKAGES_DOT_H > /dev/null 2>&1
1767      RETVAL=$?      RETVAL=$?
1768      if test "x$RETVAL" = x0 ; then      if test "x$RETVAL" = x0 ; then
1769          rm -f $PACKAGES_DOT_H".tmp"          rm -f $PACKAGES_DOT_H".tmp"

Legend:
Removed from v.1.49  
changed lines
  Added in v.1.64

  ViewVC Help
Powered by ViewVC 1.1.22